using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using RFramework;

namespace RFrameGenerate.Model
{
    public partial class T_ST_MemberAndDistribution: EntityBase<T_ST_MemberAndDistribution>, ICloneable
    { 
        public Guid? Expr1{ get;set; }   
        public Guid? MerchantGuid{ get;set; }   
        public string MemberMobilePhone{ get;set; }
        public string MemberName{ get;set; }
        public string MemberNickName{ get;set; }
        public string HeadImgUrl{ get;set; }
        public string Sex{ get;set; }
        public string City{ get;set; }
        public string Province{ get;set; }
        public string Country{ get;set; }
        public decimal? Balance{ get;set; }   
        public Guid DistributionPropGuid{ get;set; }   
        public Guid? MemberGuid{ get;set; }   
        public string DistributionName{ get;set; }
        public Guid? ParentDistributionPropGuid{ get;set; }   
        public int? SubMemberNum{ get;set; }   
        public string DistributionTelphone{ get;set; }
        public string RQCode{ get;set; }
        public DateTime? JoinDateTime{ get;set; }   
        public string SuperiorName{ get;set; }
        public decimal? DistributionAmount{ get;set; }   
        public decimal? DistributionCommissions{ get;set; }   
        public decimal? AmountFrozen{ get;set; }   
        public decimal? WithdrawalAmount{ get;set; }   
        public bool? IsEnable{ get;set; }   
        public string MarketingField{ get;set; }
        public Guid? SMerchantGuid{ get;set; }   
      
        public override string ToString()
        {
            StringBuilder sb = this.EntityToGetKeyValue();
            if (sb == null)
                return base.ToString();
            else
            {
                return sb.ToString();
            }
        }
        
        #region 创建副本
        /// <summary>
        /// 创建当前 System.Object 的浅表副本
        /// </summary>
        /// <returns>返回当前实例的浅表副本,(如果当前实例中有引用对象,引用对象的地址还是指向原来的地址)</returns>
        public object Clone()
        {
            return this.MemberwiseClone();
        }
        
        /// <summary>
        /// 创建当前 System.Object 的深表副本
        /// </summary>
        /// <returns>返回当前实例的深表副本,(如果当前实例中有引用对象,引用对象的地址还是指向原来的地址)</returns>
        public T_ST_MemberAndDistribution DeepClone()
        {
            using (System.IO.Stream objectStream = new System.IO.MemoryStream())
            {
                System.Runtime.Serialization.IFormatter formatter = new System.Runtime.Serialization.Formatters.Binary.BinaryFormatter();
                formatter.Serialize(objectStream, this);
                objectStream.Seek(0, System.IO.SeekOrigin.Begin);
                return formatter.Deserialize(objectStream) as T_ST_MemberAndDistribution;
            }
        }
        /// <summary>
        /// 创建当前 System.Object 的浅表副本
        /// </summary>
        /// <returns>返回当前实例的浅表副本,(如果当前实例中有引用对象,引用对象的地址还是指向原来的地址)</returns>
        public T_ST_MemberAndDistribution ShallowClone()
        {
            return Clone() as T_ST_MemberAndDistribution;
        }

        #endregion
        
        #region 实体相互转换        
        protected override T_ST_MemberAndDistribution CurrentEntity()
        {
            return this;
        }
        #endregion
    }
}

